import React, { useEffect, useRef, useState } from 'react';
import {
    AddDatabaseRequest,
    DatabaseType,
    databaseNameMapping,
    databaseProtocolMapping,
    readInSchemaFromBackend,
    useAppDispatch,
    useDatabaseAPI,
    useGraphQueryResult,
    useSchemaAPI,
    useSchemaGraphology,
    useSessionCache,
  } from '@graphpolaris/shared/lib/data-access';
import { SchemaUtils, schemaExpandRelation, schemaGraphology2Reactflow } from '@graphpolaris/shared/lib/schema/schema-utils';
import ReactFlow, {
    ControlButton,
    Controls,
    Node,
    Edge,
    ReactFlowProvider,
    useNodesState,
    useEdgesState,
    ReactFlowInstance,
    Background,
  } from 'reactflow';
import { DbItem } from './dbItem';
import { DbSolo } from './dbSolo';
import { SchemaFromBackend } from '@graphpolaris/shared/lib/schema';
import Broker from '@graphpolaris/shared/lib/data-access/socket/broker';
import { schemaGraphology } from '@graphpolaris/shared/lib/data-access/store/schemaSlice';
export const DbPullItems = () => {
    const session = useSessionCache();
    const schemaGraphology = useSchemaGraphology();
    const expandedSchema = schemaExpandRelation(schemaGraphology);
    const schemaFlow = schemaGraphology2Reactflow(expandedSchema);

    // Fetch DB Information from Schema
    // Fill in Simpler Data like Total Nodes and Edges
    // Create a multidimensional array for Node types and counts
    // Create a multidimensional array for Relations between Nodes and counts
    if (session.databases.length > 1){
    return(session.databases.map((db: any) => (
        <DbItem EdgeSet={schemaFlow.edges} NodeSet={schemaFlow.nodes} Name={db} Count={0}        
        />
    )))};
    if (session.databases.length == 1){
        console.log(schemaFlow.nodes);
        console.log(schemaFlow.edges);
        return(session.databases.map((db: any) => (
                <DbSolo Name={db} EdgeSet={schemaFlow.edges} NodeSet={schemaFlow.nodes}       
                />
            ))
        )
    }
    return(
        <div>
            Database Not Found, Connect to a Database!
        </div>
    )
};
