export default class GeoEdge {
  public id: string | number;
  public from: string | number;
  public to: string | number;
  public source: [number, number] | null;
  public target: [number, number] | null;
  public directed: boolean;
  public data: { [key: string]: any };
  public count: number;
  public isEdge: boolean;

  constructor({
    id,
    from,
    to,
    directed = false,
    data = {},
  }: {
    id: string | number;
    from: string | number;
    to: string | number;
    directed?: boolean;
    data?: { [key: string]: any };
  }) {
    this.id = id;
    this.from = from;
    this.to = to;
    this.source = null;
    this.target = null;
    this.directed = directed;
    this.data = data;
    this.count = 1;
    this.isEdge = true;
  }

  getSourceNodeId = (): string | number => this.from;
  getTargetNodeId = (): string | number => this.to;
}
